function goBack()
{
    history.back();
    return false;
}

function checkPagination()
{
    var wrapper = this.parent();
    var rowsPerPage = this.fnSettings()._iDisplayLength;
    var rowsToShow = this.fnSettings().fnRecordsDisplay();
    var minRowsPerPage = this.fnSettings().aLengthMenu[0][0];
    if ( rowsToShow <= rowsPerPage || rowsPerPage == -1 )
    {
        $('.dataTables_paginate', wrapper).css('visibility', 'hidden');
    }
    else
    {
        $('.dataTables_paginate', wrapper).css('visibility', 'visible');
    }
    if ( rowsToShow <= minRowsPerPage )
    {
        $('.dataTables_length', wrapper).css('visibility', 'hidden');
    }
    else
    {
        $('.dataTables_length', wrapper).css('visibility', 'visible');
    }
}

function showSuccessMessage(message)
{
    $("#error_message").hide();
    $("#success_message").html(message).show();

    setTimeout( function(){
        $("#success_message").hide('slow');
    }, 5000);
}

function showErrorMessage(message)
{
    $("#success_message").hide();
    $("#error_message").html(message).show();

    setTimeout( function(){
        $("#error_message").hide('slow');
    }, 10000);
}

function showGenericErrorMessage()
{
    $("#success_message").hide();
    $("#error_message").html("An unexpected error occurred communicating to the server.  Please wait and try again.").show();

    setTimeout( function(){
        $("#error_message").hide('slow');
    }, 10000);
}

function fillAddressForm()
{
    var place = autocomplete.getPlace();

    if(place != null)
    {
        if(place.address_components != null)
        {
            for (var i = 0; i < place.address_components.length; i++)
            {
                var component = place.address_components[i];
                var componentType = component.types[0];
                if (componentType == "street_number")
                {
                    streetNumber = component["short_name"];
                }
                else if (componentType == "route")
                {
                    route = component["long_name"];
                }
                else if (componentType == "locality")
                {
                    locality = component["long_name"];
                }
                else if (componentType == "administrative_area_level_1")
                {
                    administrativeAreaLevel1 = component["short_name"];
                }
                else if (componentType == "postal_code")
                {
                    postalCode = component["short_name"];
                }
            }
        }

        $("#city").attr("value", locality);
        $("#zip").attr("value", postalCode);
        $("#state").val(administrativeAreaLevel1);

        fullAddress = streetNumber + " " + route;

        if(fullAddress != "" && locality != "" && administrativeAreaLevel1 != "" && postalCode != "")
        {
            $("#addressSuggestionUsed").val("true");
        }
        else
        {
            $("#addressSuggestionUsed").val("false");
        }
    }

    setTimeout(function(){ $("#address").val(fullAddress); },10);
}

$(document).ready(function() {
    $('.link').tooltip();

    var windowHeight = $(window).height();
    $('.content-overall').css("min-height", windowHeight-300);

    $.ajaxSetup({
        beforeSend: checkPulse
    });
});

$(document).bind("idle.idleTimer", function(){
    window.location = "/j_spring_security_logout";
});

function checkPulse(XMLHttpRequest)
{
    var location = window.location.href;
    $.ajax({
        url: "/checkPulse",
        type: 'GET',
        async: false,
        beforeSend: null,
        success: function(msg) {
            if (msg.resultMsg == 'invalid') {
                XMLHttpRequest.abort();
                window.location = '/login';
            }
        }
    });
}

function printObjectProperties(someObject)
{
    var debugMessage = "";
    for (var property in someObject)
    {
        if(property != "source")
        {
            debugMessage += "property: "+ property+ " value: ["+ someObject[property]+ "]\n";
        }
    }

    console.log("OUTPUT: " + debugMessage);
}

function sleep(milliseconds)
{
    var start = new Date().getTime();
    for (var i = 0; i < 1e7; i++)
    {
        if ((new Date().getTime() - start) > milliseconds)
        {
            break;
        }
    }
}
